# opt-demos.tcl---demo tcl scripts

#   May 1996  VP

set frame DEMOS
set frametitle "Demonstration TCL Scripts"
set icontitle "TclDemos"

set directory "$env(TCLHOME)/demo-scripts"
set selection {}

proc make-frame {} {
   global env

    :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-name "[self icon-title]" :resize F

      :panel P1 :layout T :padx 10 :pady 10
         :layout H; :row-gap 0

         :text DIRECTORY :label "Directory:" :w 60 :shifters T
         :button UP   :label Up
         :button DOWN :label Down

      :panel P2 :layout T :padx 10
         :list DIRECTORYLIST :exclusive T :rows 10 :cols 80

      :panel P3 :layout T :padx 10 :pady 10
         :layout H; :col-gap 10
         :button REDISPLAY  :label Redisplay
         :button EXECUTE    :label Execute
         :hskip 80
         :button HELP       :label Help...
      
      :show T
} 

proc click-execute {} {
   global directorylist selection directory
   if {[llength $selection]==0} then {
      set-footer "no script selected!!!"
      return
   }
   if {[llength $selection]>1} then {
      set-footer "multiple scripts selected!!!"
      return
   }
   set target [lindex $directorylist $selection]
   if {[string range $target 0 0] == "d"} then {
      set-footer "can't execute a directory!!!"
      return
   }
   set file [last $target]
   if {[last $target] == "."} then {set-footer "can't execute `.'"; return}
   if {[last $target] == ".."} then {set-footer "can't execute `.'"; return}
   set-footer "executing $directory/$file..."
   set z [catch {source  $directory/$file} m]
   if {$z!=0} then {set-footer $m} else {clear-footer}
}

proc click-directory name {
   global directory
   set directory $name
   click-redisplay
}

proc click-directorylist {v i} {
   global selection 
   set selection $i        
}

proc click-redisplay {} {
   global directory selection
   :modify DIRECTORY :value "$directory"
   read-directory $directory
   paint-directory $directory
   set selection {}
}

proc click-up {} {
  global directory
  set directory [directory-up $directory]
  click-redisplay
}

proc click-down {} {
  global directory selection
  set directory [directory-down $directory $selection]
  click-redisplay
}
