# pdb.tcl---directory browser

# Fri Jul 15 09:46:44 BST 1994, SCL
#   added check for OS version due to different output from ls


set started 0

set frame PDB
set frametitle "Polyarray Directory Browser"
set icontitle PolyBrowser

set defdir [file join $env(HOME) .eg-polyarrays]
set directory $defdir
set file ""
set savefile ""

loadsource sb.common 

proc make-frame {} {
   global env

   :frame [self frame-name] :label "[self frame-title]" :show-footer T  \
      :icon-image "@$env(ICONHOME)/spectrum"  \
      :icon-name [self icon-title]

    :panel P1 :layout V :pady 5 :padx 10
     :layout H
      :text DIRECTORY :label "Directory" :w 40 :shifters T
      :hskip 100
      :button UP; :button DOWN

    :panel P2 :layout V :padx 10
      :list DIRECTORYLIST :rows 10 :cols 80 :exclusive T :double-click T

    :panel P3 :layout V :pady 5 :padx 10
     :layout H; :row-gap 10; :col-gap 5
      :button LOAD;  :button SAVE
      :hskip 20; :col-gap 0
      :button SAVE-AS :label "Save As"
      :text FILE :label "" :w 30
      :hskip 60
      :button REDISPLAY; :button HELP 

    :show T
}

proc double-click arg {
   global debug
   if {$debug} then {puts stderr "double-click with argument \{$arg\}"}
   set w [lindex $arg 2]

   switch -glob $w {
        DIRECTORYLIST        {click-down-or-load}
	default     {puts stdout $arg}
   }
}

proc click-file f {
   global savefile
   set savefile $f
}

proc click-load {} {
   global selection directorylist directory file
   if {[llength $selection] == 0} then {
      set-footer "no polyarray file selected!!!"
      return
   }
   if {[llength $selection] > 1} then {
      set-footer "multiple selections!!!"
      return
   }
   set target [lindex $directorylist $selection]
   set link [last $target]
   set type [file type [file join $directory $link]]
   if {$type == "link"} then {
      set link [file readlink $link]
      set type [file type [file join $directory $link]]
   }
   if {$type == "directory"} then {
      set-footer "can't load a directory!!!"
      return
   }
   set file [last $target]
   inform sd load-polyarray-file $directory $file
}

proc click-down-or-load {} {
   global selection directorylist directory file
   if {[llength $selection] == 0} then {
      set-footer "no polyarray file selected!!!"
      return
   }
   if {[llength $selection] > 1} then {
      set-footer "multiple selections!!!"
      return
   }
   set target [lindex $directorylist $selection]
   set file [last $target]
   if {[file type [file join $directory $file]] == "link"} then {
      set file [file readlink [file join $directory $file]]
   }
   if {[file type [file join $directory $file]] != "directory"} then {
       inform sd load-polyarray-file $directory $file
       return
   }
   if {"$file" == "."} then {click-redisplay; return}
   if {"$file" == ".."} then {click-up; return}
   if {$directory == "/"} then {set directory ""}
   set directory [file join $directory $file]
   click-redisplay
   set selection {}
}

proc click-save {} {
   global directory file
   if {"$file" == ""} then {
      set-footer "you haven't loaded a polyarray file yet!!!"
      return
   }
   inform sd save-polyarray-file $directory $file pdb
}

proc click-save-as {} {
   global directory savefile
   if {"$savefile" == ""} then {
      set-footer "you haven't given a new file name!!!"
      return
   }
   inform sd save-polyarray-file $directory $savefile pdb
}

proc start args {
   global env defdir started
    if {$started == 0} then {
	make-frame
	set z [catch {:file mkdir $defdir}]
	if {!$z} then {
	    :file copy [file join $env(TCLHOME) default-poly-gate] $defdir
	    set-footer "Default directory and polygon file created ..."
	}
	set started 1
    } else {open-frame}
   click-redisplay
}
